<?php
/*
Plugin Name: CAS Authentication
Version: 2.3.2
Plugin URI: Not public
Description: This plugin is a modification of the plugin developed by  Yuta Sakurai http://github.com/sakuraiyuta/wordpress-casi Adding UBC Specific capabilities (Legacy hash checking and PUID identifiers.
Author:  Yuta Sakurai modifified for UBC by Scott McMillan
Author URI: http://ctlt.ubc.ca 
License: GPLv2
*/

/* Copyright (C) 2010 Yuta Sakurai <sakurai.yuta@gmail.com>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


// Include the has function.
if ( !defined('XMLRPC_REQUEST') ) {

if ( isset( $_POST['custom_lmslogin'] ) == "bypassCWL4BasicLTI" ) {
	require_once( WPMU_PLUGIN_DIR.'/IMSBasicLTI.php' );
} else {
	include_once( 'cas-authentication/legacy-cwl-unique-id-hash.php' );

	add_action( 'network_admin_menu', 'cas_authentication_add_options_page' );

	$cas_authentication_opt = get_site_option( 'cas_authentication_options' );
	$cas_configured = true;

	// try to configure the phpCAS client
	if ( $cas_authentication_opt['include_path'] == '' || (include_once $cas_authentication_opt['include_path']) != true ) {
    		$cas_configured = false;
	}

	if ( $cas_authentication_opt['server_hostname'] == '' || $cas_authentication_opt['server_path'] == '' || intval( $cas_authentication_opt['server_port'] ) == 0 ) {
  		$cas_configured = false;
	} 

	if ( $cas_configured ) {
		//phpCAS::client($cas_authentication_opt['cas_version'],
    		/* CTLT ADD */
    		// hardcoded the SAML client version we only want SAML here.
    		phpCAS::client( SAML_VERSION_1_1, $cas_authentication_opt['server_hostname'], intval($cas_authentication_opt['server_port']), $cas_authentication_opt['server_path'] );
    		/* CTLT END */

    		// function added in phpCAS v. 0.6.0
    		// checking for static method existance is frustrating in php4
    		$phpCas = new phpCas();

    		if ( method_exists( $phpCas, 'setNoCasServerValidation' ) ) {
        		phpCAS::setNoCasServerValidation();
    			unset( $phpCas );
    			// if you want to set a cert, replace the above few lines
		}
	}	


	// plugin hooks into authentication system
	add_filter( 'wp_authenticate', array('CASAuthentication', 'authenticate'), 10, 3 );
	add_action( 'wp_logout', array('CASAuthentication', 'logout') );
	add_action( 'lost_password', array('CASAuthentication', 'disable_function') );
	add_action( 'retrieve_password', array('CASAuthentication', 'disable_function') );
	add_action( 'password_reset', array('CASAuthentication', 'disable_function') );
	add_filter( 'check_password', array('CASAuthentication', 'override_password_check'), 10, 4 );
	add_action( 'lost_password', array('CASAuthentication', 'disable_function') );
	add_filter( 'show_password_fields', array('CASAuthentication', 'show_password_fields') );
	add_filter( 'login_url', array('CASAuthentication', 'bypass_reauth'), 1 );


	$redirect_to = '';
	if ( isset( $_GET['redirect_to'] ) ) {
		 $redirect_to = $_GET['redirect_to'];
	}	 

	if ( !class_exists( 'CASAuthentication' ) ) {
    		class CASAuthentication {

        		// password used by the plugin
			function passwordRoot() {
				return 'Authenticated through CAS';
        		}
	
    			/*
     	 		We call phpCAS to authenticate the user at the appropriate time
     	 		(the script dies there if login was unsuccessful)
     	 		If the user has not logged in previously, we create an accout for them
     			*/
        
			function authenticate( &$username, &$password ) {
				global $wpdb, $using_cookie, $cas_authentication_opt, $cas_configured, $redirect_to;

        			if ( !$cas_configured ) {
                			die("cas-authentication plugin not configured");
				} 
            			
				// Reset values from input ($_POST and $_COOKIE)
            			$username = $password = '';

            			phpCAS::forceAuthentication();

            			// might as well be paranoid
            			if ( !phpCAS::isAuthenticated() ) {
					wp_die( __( 'CAS Authentication Failure.' ) );
					exit();
	    			}
						
				/* CTLT START  get SAML attributes */
	    			foreach ( phpCAS::getAttributes() as $key => $value ) {

	   				if ( $key == 'givenName' ) {
						$first_name = "$value";	
					}

					if ( $key == 'sn' ) {
                				$last_name = "$value";  
                			}
		
					if ( $key == 'studentNumber' ) {
						$role_ids[]  = "$value";
						$ubc_student_role = "student";			
					}	
		
					if ( $key == 'employeeNumber' ) {
                        			$role_ids[]  = "$value";
						$ubc_employee_role   = 'employee';
                			} 		

					if ( $key == 'puid' ) {
                        			$puid  = "$value";
                			} 
			
					if ( $key == 'mail' ) {
                                                $mail  = "$value";
					}

					if ( $key == 'ubcAffiliation' ) {
					       $ubcAffiliation = "$value";
					}

	   			}	   

				if (  empty( $ubcAffiliation ) AND $cas_authentication_opt['allowed_roles'] != 'all' ) {
                			wp_die( __( 'CAS Authentication: This service is only available to employees and students.' ) );
        			}

				// First Check if the user has an account with an associated PUID
  				$puid_check = '';
				$user_id = get_id_from_puid( $puid );
	
				if ( empty( $user_id ) ) {

					if( !empty( $role_ids ) ) {
						$user_id = get_userid_by_hashed( $role_ids );
						$hashed_id_check = $user_id;		
					}
		
					// If the user ID is not empty now update the user_meta with the puid 
					if ( !empty( $user_id ) ) {
						$add_user_puid = add_user_meta( $user_id, 'puid', $puid ); 	
			
						if ( $add_user_puid == FALSE ) {
							wp_die( __( 'CAS Authentication: FAIL unable to update user PUID contact site admin.' ) );
						}  else {
							// Now get rid of the CWLUniqueID hash no longer needed
							delete_user_meta( $user_id, 'CWLUniqueID' );
						}    
					} 
				}

 
				$password = md5( CASAuthentication::passwordRoot() );

				//if ( !empty( $user_id ) AND ( !empty( $puid_check ) || !empty( $hashed_id_check ) ) ) {
				if ( !empty( $user_id ) ) {
          
					// DELETE the  CWLUniqueID hash no longer needed
                 			delete_user_meta( $user_id, 'CWLUniqueID' );

					// user already exists get the username and set it.
					$user_info = get_userdata( $user_id );
					$username = $user_info->user_login;
					//$password = $user_info->user_pass;
					$usernameCAS = phpCAS::getUser();	
		
					// UserID should be set so authernticate.
            				if ( isset( $user_id ) AND isset( $username ) AND is_user_logged_in() != TRUE ) {
						
						CASAuthentication::sign_on_wp_user( $user_id, $username );
						CASAuthentication::redirect_after_login( $redirect_to );
					}
				
            
	  			} else {
                			// first time logging in	
					$password = md5( CASAuthentication::passwordRoot() );
					$username = phpCAS::getUser();	

                			if ( $cas_authentication_opt['new_user'] == 1 ) {
                    				// auto-registration is enabled
                    				// User is not in the WordPress database
                    				// they passed CAS and so are authorized
                    				// add them to the database

                    				$user_email = '';
                    
		    				if ( $cas_authentication_opt['email_suffix'] != '' )
                        				if ( !isset( $mail ) ) {
								$user_email = $username . '@' . $cas_authentication_opt['email_suffix'];
                        				} else {
								$user_email = $mail;
							}
							$user_info = array();
			
							// Sanitize some of the fields
							$username = sanitize_user( $username, true );
							$user_email = sanitize_email( $user_email );
							$first_name = sanitize_user( $first_name, true );
                        				$last_name = sanitize_user( $last_name, true );
                        				$user_info['user_login'] = $username;
							$user_info['user_pass'] = $password;
                        				$user_info['user_email'] = $user_email;
							$user_info['user_nicename'] = "$first_name $last_name";
                        				$user_info['display_name'] = "$first_name $last_name";
							$user_info['first_name'] = "$first_name";
							$user_info['last_name'] = "$last_name";
							$user_id = wp_insert_user( $user_info );

                        				if ( is_wp_error( $user_id ) ) {
                            					wp_die( __( 'CAS Authentication: There was an error creating the user.' ) );
                        				} else {
								if ( $user_id != '1' ) {
									/* CTLT START add SAML attributes to user_meta */
									add_user_meta( $user_id, 'puid', $puid );
					
									// Add the UBC Role mainly just for stats.
									if( isset( $ubc_employee_role ) || isset( $ubc_student_role ) ) {
										$ubc_cwl_identity = "$ubc_employee_role $ubc_student_role";
										$ubc_cwl_identity = trim( $ubc_cwl_identity);
									} else {
										//Nothing is set so guest or basic no way to tell which one.
										$ubc_cwl_identity = "guest_basic";
									}

									add_user_meta( $user_id, 'ubc_cwl_identity', "$ubc_cwl_identity" );
	
									CASAuthentication::sign_on_wp_user( $user_id, $username );	
									CASAuthentication::redirect_after_login( $redirect_to );
									/* CTLT END */
                    	 					}				
			 				}
					} // Close CAS Auth new user	

             				}
		
        			}

				/** 
                                 *  redirect_after_login if redirect_to set push there if not admin_url
                                 * 
                                 *  @param string $redirect_to
                                 */

                                function redirect_after_login( $redirect_to ) {

                                        if ( !isset( $redirect_to ) ) {
                                                $redirect_to = home_url();
                                        }
                                        wp_redirect( $redirect_to );
                                        exit();
                                }

				/** 
                                 *  sign_on_wp_user  -  after login 
                                 *  
                                 *  @param string $user_id
				 *  @param string $username
				 *  return $user
                                 */

				function sign_on_wp_user( $user_id, $username ) {
					
					$user = new WP_User( $user_id );
                                        wp_set_current_user( $user_id , $username );
                                        wp_set_auth_cookie( $user_id, false, 0 );
                                        do_action( 'wp_signon', $username );
					
					return $user;
				}

    				/*
     				 * We use the provided logout method
     				 */
        			function logout() {
            				global $cas_configured;

            				if ( !$cas_configured ) { 
                				die( "cas-authentication not configured" );
					}		
		        
					wp_clear_auth_cookie();
					//phpCas::logoutWithRedirectService( get_settings('siteurl') );
				        phpCAS::logout();
					exit();
        			}

        			/*
         			* Remove the reauth=1 parameter from the login URL, if applicable. This allows
         			* us to transparently bypass the mucking about with cookies that happens in
         			* wp-login.php immediately after wp_signon when a user e.g. navigates directly
         			* to wp-admin.
         			*/
        			function bypass_reauth( $login_url ) {
	    				$login_url = get_site_url('1').'/wp-login.php';
	    				$login_url = remove_query_arg('reauth', $login_url);
	    				return $login_url;
        			}

    				/*
     	 			* Don't show password fields on user profile page.
     	 			*/
        			function show_password_fields( $show_password_fields ) {
            				return false;
        			}

        			function disable_function() {
            				die('Disabled');
        			}

				function override_password_check( $check, $password, $hash, $user_id ) {
      					return $check;
    				}
    			}
			}

//----------------------------------------------------------------------------------------
//              SOME FUNCTIONS TO DEAL WITH UBC SPECIFIC / LEGACY STUFF 
//---------------------------------------------------------------------------------------
 
/*
 * Check it the user is in the system alread. Looing for valid PUID or legacy hashed. 
 */

	function get_id_from_puid( $puid ) {
                global $wpdb;

                $result = $wpdb->get_row( $wpdb->prepare( "SELECT user_id FROM $wpdb->usermeta WHERE meta_key = 'puid' AND meta_value = '%s'", $puid ), ARRAY_A );
		
		if( $result != null ) {
                 return $result['user_id'];
		}
        }

     /**
     * get_userdata_by_cwl_unique_id - get WordPress user data using CWL unique ID
     *
     * @param string $CWLUniqueID - CWL unique ID
     * @return WordPress user data or NULL if user is not found
     */
    function get_userid_by_hashed( $role_ids ) {
        global $wpdb;
	
	foreach( $role_ids as $role ) {

        	$ID = cwl_salt_hash($role);

        	$result = $wpdb->get_row($wpdb->prepare( "SELECT user_id FROM $wpdb->usermeta WHERE meta_key = 'CWLUniqueID' AND meta_value = '%s'", $ID ), ARRAY_A );
	
		if( $result != null ) {
                 return $result['user_id'];
                }

	}
	
    }



//----------------------------------------------------------------------------
//		ADMIN OPTION PAGE FUNCTIONS
//----------------------------------------------------------------------------

function cas_authentication_add_options_page() {

	if ( function_exists('add_options_page') ) {
        	add_options_page( 'CAS Authentication', 'CAS Authentication', 'manage_network', 'cas_authentication_options_page', 'cas_authentication_options_page' );
    	}
	
	add_submenu_page( 'settings.php', 'CAS Authentication', 'CAS Authentication', 'manage_sites', 'cas_authentication_options_page', 'cas_authentication_options_page' );

}


function cas_authentication_options_page() {
    global $wpdb;

    // Setup Default Options Array
    $optionarray_def = array(
        'new_user' => FALSE,
        //'new_blog' => FALSE,
        'register_existing_blog' => FALSE,
        'register_blog_ids' => '1',
        'register_blog_role' => '',
        //'hash_domain' => FALSE,
        'allowed_roles' => 'all',
	'redirect_url' => '',
        //'blog_prefix' => 'cas_',
        'email_suffix' => 'yourschool.edu',
        'cas_version' => SAML_VERSION_1_1,
        'include_path' => '',
        'server_hostname' => 'yourschool.edu',
        'server_port' => '443',
        'server_path' => ''
    );

    if ( isset( $_POST['submit'] ) ) {
    	 if( !wp_verify_nonce( $_POST['_wpnonce'],'_wpnonce') ) {
		wp_die( __( 'Error: nounce did not match.' ) );
	}

    	// Options Array Update
        $optionarray_update = array (
            'new_user' => $_POST['new_user'],
            //'new_blog' => $_POST['new_blog'],
            'register_existing_blog' => $_POST['register_existing_blog'],
	    'register_blog_ids' => $_POST['register_blog_ids'],
            'register_blog_role' => $_POST['register_blog_role'],
            //'hash_domain' => $_POST['hash_domain'],
            'allowed_roles' => $_POST['allowed_roles'],
	    'redirect_url' => $_POST['redirect_url'],
  	    //'blog_prefix' => $_POST['blog_prefix'],
            'email_suffix' => $_POST['email_suffix'],
            'include_path' => $_POST['include_path'],
            'cas_version' => $_POST['cas_version'],
            'server_hostname' => $_POST['server_hostname'],
            'server_port' => $_POST['server_port'],
            'server_path' => $_POST['server_path']
        );

        update_site_option( 'cas_authentication_options', $optionarray_update );
    }

    // Get Options
    $optionarray_def = get_site_option( 'cas_authentication_options' );
    global $current_site, $wpdb;
    $editblog_roles = get_blog_option(
        $current_site->id,
        $wpdb->get_blog_prefix($current_site->id) . "user_roles"
    );
?>
<div class="wrap">
    <h2>CAS Authentication Options</h2>
<?php
$network_admin_url = network_admin_url();
?>	
    <form method="post" action="<?php echo $network_admin_url.'?page=cas_authentication_options_page'?>&updated=true">

        <fieldset class="options">

            <h3>User registration options</h3>
            <h4>!!!CAUTION!!!</h4>
            <p>
                If you want to use <em>Auto-register new blogs</em>, <strong>you must set &quot;Network Activate&quot; in Plugins page, not use &quot;Activate&quot;!</strong>
            </p>

            <table width="700px" cellspacing="2" cellpadding="5" class="editform">
                <tr>
                    <td colspan="2">Checking <em>Auto-register new users</em> will automatically create a new user (with role of Subscriber) upon successful login of a new visitor to the site.</td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row">Auto-register new users?</th>
                    <td width="15px"><input name="new_user" type="checkbox" id="new_user_inp" value="1" <?php checked('1', $optionarray_def['new_user']); ?> /></td>
                </tr>
        <!--       
	 <tr>
                    <td colspan="2">
                        Checking <em>Auto-register new blogs</em> will automatically create a new blog (with role of Administrator) upon successful login of a new visitor to the site.
                    </td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row" valign="top">Auto-register new blogs?</th>
                    <td width="15px"><input name="new_blog" type="checkbox" id="new_blog_inp" value="1" <?php checked('1', $optionarray_def['new_blog']); ?> /></td>
                </tr>
-->
		 <tr valign="center">
                    <th width="200px" scope="row">Who is this service available to?</th>
                    <td width="15px">
			<ul>
                        <li>Employees / Students <input name="allowed_roles" type="radio" id="allowed_roles" value="employee_student" <?php checked('employee_student', $optionarray_def['allowed_roles']); ?> /></li>
                    	<lI>All Roles (including basic) <input name="allowed_roles" type="radio" id="allowed_roles" value="all" <?php checked('all', $optionarray_def['allowed_roles']); ?> /></ul></li>
			</td>
                </tr>
                <tr>
                    <td colspan="2">
                        Checking <em>Auto-register new cas-user for existing blogs</em> will automatically register new cas-user for existing blog upon successful login of a new visitor to the site.
                    </td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row">Auto-register new cas-user for existing blogs?</th>
                    <td width="15px">
                        <input name="register_existing_blog" type="checkbox" id="register_existing_blog_inp" value="1" <?php checked('1', $optionarray_def['register_existing_blog']); ?> />
                    </td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row">Please insert blog-ids sepalated by camma. (ex: 1,5,10)</th>
                    <td width="15px">
                        <input name="register_blog_ids" type="text" id="register_blog_ids_inp" value="<?php echo (! count(explode(',', $optionarray_def['register_blog_ids']))) ? "" : $optionarray_def['register_blog_ids']; ?>" />
                    </td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row">You can select a new cas-user's role of existing blog.</th>
                    <td width="15px">
                        <select name="register_blog_role" type="checkbox" id="register_blog_role">
                            <?php foreach ( $editblog_roles as $role => $role_assoc ) : ?>
                            <?php $name = translate_user_role( $role_assoc['name'] ); ?>
                            <option <?php selected( $role, $optionarray_def['register_blog_role'] ); ?> value="<?php echo esc_attr($role); ?>"><?php echo esc_html($name); ?></option>
                            <?php endforeach; ?>
                        </select>
                    </td>
                </tr>
                <!--
		<tr>
                    <td colspan="2">
                        Checking <em>Use hashed blog-path</em> will create blog-path by sha1-hash based on username. Default is raw-username.
                    </td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row">Use hashed blog-path?</th>
                    <td width="15px"><input name="hash_domain" type="checkbox" id="hash_domain_inp" value="1" <?php checked('1', $optionarray_def['hash_domain']); ?> /></td>
                </tr>
                <tr>
                    <td colspan="2">
                        You can set prefix on blog-path. It's strongly recommended.
                    </td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row">blog-path prefix</th>
                    <td><input type="text" name="blog_prefix" id="blog_prefix_inp" value="<?php echo $optionarray_def['blog_prefix']; ?>" size="35" /></td>
                </tr>
		-->
                <tr>
                    <td colspan="2">If you know that the owner of the CAS authentication service issues email addresses based on their netids, you can predict your users' emails here</td>
                </tr>
                <tr valign="center">
                    <th width="200px" scope="row">E-mail Suffix</th>
                    <td>netid@<input type="text" name="email_suffix" id="email_suffix_inp" value="<?php echo $optionarray_def['email_suffix']; ?>" size="35" /></td>
                </tr>
            </table>

            <h3>phpCAS options</h3>
            <p>Note: Once you fill in these options, wordpress authentication will happen through CAS, even if you misconfigure it. To avoid being locked out of Wordpress, use a second browser to check your settings before you end this session as administrator. If you get an error in the other browser, correct your settings here. If you can not resolve the issue, disable this plug-in.</p>

            <h4>php CAS include path</h4>
            <table width="700px" cellspacing="2" cellpadding="5" class="editform">
                <tr>
                    <td colspan="2">Full absolute path to CAS.php script</td>
                </tr>
                <tr valign="center">
                    <th width="300px" scope="row">CAS.php path</th>
                    <td><input type="text" name="include_path" id="include_path_inp" value="<?php echo $optionarray_def['include_path']; ?>" size="35" /></td>
                </tr>
            </table>

            <h4>phpCAS::client() parameters</h4>
            <table width="700px" cellspacing="2" cellpadding="5" class="editform">
		<!-- /* CTLT START Disable other options CTLT version since we only want SAML */
		<tr valign="center">
                    <th width="300px" scope="row">CAS verions</th>
                    <td><select name="cas_version" id="cas_version_inp">
                            <option value="SAML_VERSION_1_1" <?php echo ($optionarray_def['cas_version'] == 'SAML_VERSION_1_1')?'selected':''; ?>>SAML_VERSION_1_1</option>
			    <option value="2.0" <?php echo ($optionarray_def['cas_version'] == '2.0')?'selected':''; ?>>CAS_VERSION_2_0</option>
                            <option value="1.0" <?php echo ($optionarray_def['cas_version'] == '1.0')?'selected':''; ?>>CAS_VERSION_1_0</option>    
			</td>
                    </tr>
		    -->
		 <tr valign="center">
                    <th width="300px" scope="row">CAS version</th>
                        <td>SAML_VERSION_1_1</td>
                    </tr>
		  <!-- /* CTLT END */ -->
                    <tr valign="center">
                        <th width="300px" scope="row">server hostname</th>
                        <td><input type="text" name="server_hostname" id="server_hostname_inp" value="<?php echo $optionarray_def['server_hostname']; ?>" size="35" /></td>
                    </tr>
                    <tr valign="center">
                        <th width="300px" scope="row">server port</th>
                        <td><input type="text" name="server_port" id="server_port_inp" value="<?php echo $optionarray_def['server_port']; ?>" size="35" /></td>
                    </tr>
                    <tr valign="center">
                        <th width="300px" scope="row">server path</th>
                        <td><input type="text" name="server_path" id="server_path_inp" value="<?php echo $optionarray_def['server_path']; ?>" size="35" /></td>
                    </tr>
                </table>
            </fieldset>
            <p />
            <div class="submit">
                <input type="submit" name="submit" value="<?php _e('Update Options') ?> &raquo;" />
            </div>
	<?php 
	wp_nonce_field('_wpnonce'); 
	?>
        </form>
<?php
  }
 } // LTI CHECK
} //LMS CHECK
?>
